require net
require recode
readonly REVERSE_CFG="$CALLMONITOR_LIBDIR/reverse/provider.cfg"
reverse_lookup() {
local number=$1 prov area_prov child afile name exit
case $number in
00*|[^0]*|*[^0-9]*) return 1;
esac
_reverse_choose_provider
afile="/var/run/phonebook/lookup-$area_prov-$number"
_reverse_lookup "$area_prov" "$number" | _reverse_atomic "$afile" & child=$!
name=$(_reverse_lookup "$prov" "$number"); exit=$?
if ! empty "$name"; then
echo "$name"
exit=0
else
wait $child
name=$(cat "$afile" 2>/dev/null); exit=$?
if ! empty "$name"; then
echo "$number ($name)" ## $name is only city
exit=0
fi
fi
{ kill "$child" 2>/dev/null; rm -f "$afile"; } &
return $exit
}
_reverse_choose_provider() {
if grep -q "^R[^	]*	$CALLMONITOR_REVERSE_PROVIDER	" "$REVERSE_CFG" > /dev/null; then
prov=$CALLMONITOR_REVERSE_PROVIDER
else
prov=$(grep '^R\*' "$REVERSE_CFG" | cut -f2)
fi
if grep -q "^A[^	]*	$CALLMONITOR_AREA_PROVIDER	" "$REVERSE_CFG" > /dev/null; then
area_prov=$CALLMONITOR_AREA_PROVIDER
else
area_prov=
fi
}
_reverse_atomic() {
local file=$1 tmp=$1.tmp
cat > "$tmp" && mv "$tmp" "$file" || rm "$tmp"
}
_reverse_lookup() {
local exit=0 result
result=$(_reverse_query_provider "$@"); exit=$?
case $result in
OK:*) echo "${result#OK:}"; return 0 ;;
NA:*) echo ""; return 1 ;;
*)    echo ""; return 2 ;;
esac
}
readonly REVERSE_OK='s/^/OK:/; p; q'
readonly REVERSE_NA='s/.*/NA:/; p; q'
_reverse_query_provider() {
local prov=$1 number=$2 exit=0
if empty "$prov"; then return 0; fi
eval $({
{ _reverse_${prov}_request "$number"; echo exit=$? >&4; } |
_reverse_${prov}_extract
} 4>&1 >&9)
return $(( exit == 141 ? 0 : exit ))
} 9>&1
readonly REVERSE_SANITIZE='
s#<[^>]*># #g
s#&nbsp;# #g
s#&amp;#\&#g
s#&lt;#<#g
s#&gt;#>#g
s#&quot;#"#g
s#&apos;#'\''#g
s#[[:space:] ]\+# #g
s#,\( *,\)\+#,#
s#^[, ]*##
s# \([,)]\)#\1#g
s#\([(]\) #\1#g
s#[, ]*$##
'
_reverse_load() {
local provider=$1
if [ -z "$provider" ]; then return; fi
local file=$CALLMONITOR_LIBDIR/reverse/$provider.sh
if [ -e "$file" ]; then
. "$file"
fi
}
_reverse_init() {
local prov area_prov
_reverse_choose_provider
_reverse_load "$CALLMONITOR_REVERSE_PROVIDER"
_reverse_load "$CALLMONITOR_AREA_PROVIDER"
unset -f _reverse_init
}
_reverse_init
